local Bullet = EntityManager.derive("Base")

function Bullet:init(x , y, dir)
	self.x = x or 0
	self.y = y or 0
	self.speed = 500
	self.dir = dir
	self.image = Assets.getImage("bullet1")
	self.animtimer = 0.1
	self.imagef = 1
end

function Bullet:update(dt)
	if self.dir == 1 then
		self.x = self.x + self.speed * dt
	else
		self.x = self.x - self.speed * dt
	end

	if self.x > 800 then self.alive = false end

	self.animtimer = self.animtimer - 1 * dt
	if self.animtimer <= 0 and self.imagef == 1 then
		self.image = Assets.getImage("bullet2")
		self.imagef = 2
		self.animtimer = 0.1
	elseif self.animtimer <= 0 and self.imagef == 2 then
		self.image = Assets.getImage("bullet1")
		self.imagef = 1
		self.animtimer = 0.1
	end
end

function Bullet:setDir(dir)
	self.dir = dir
end

function Bullet:draw()
	love.graphics.draw(self.image, self.x, self.y)
end

return Bullet