EntityManager = {}
EntityManager.objects = {}
EntityManager.register = {}


function EntityManager.init()
	EntityManager.register["Player"] = love.filesystem.load("Player.lua")
	EntityManager.register["Bullet"] = love.filesystem.load("Bullet.lua")
	EntityManager.register["SBG"] = love.filesystem.load("ScrollingBackground.lua")
	EntityManager.register["Goblin"] = love.filesystem.load("Goblin.lua")
end

function EntityManager.derive(name)
	return love.filesystem.load(name .. ".lua")()
end

function EntityManager.create(name, x, y)
	x = x or 0
	y = y or 0
	if EntityManager.register[name] then
		local entity = EntityManager.register[name]()
		
		entity:init()
		entity:setPosition(x,y)

		EntityManager.objects[#EntityManager.objects + 1] = entity
		return EntityManager.objects[#EntityManager.objects]
	else
		print("Error creating entity, an entity with the name " .. name .. " does not exist.")
		return nil
	end
end

function EntityManager.update(dt)
	for i, e in pairs(EntityManager.objects) do
		if e.update then
			e:update(dt)
			if e:isAlive() ~= true then
				table.remove(EntityManager.objects, i)
			end
		end
	end
end

function EntityManager.draw()
	local drawn = 0
	for i, e in pairs(EntityManager.objects) do
		if e.draw then
			e:draw()
			drawn = i
		end
	end
	print(drawn)
end