local Player = EntityManager.derive("Base")

function Player:init()
	self.image = Assets.getImage("player")
	self.speed = 400
	self.cooldown = 0
end

function Player:update(dt)
	if love.keyboard.isDown("w") then
		self.y = self.y - self.speed * dt
	end
	if love.keyboard.isDown("s") then
		self.y = self.y + self.speed * dt
	end
	if love.keyboard.isDown("a") then
		self.x = self.x - self.speed * dt
	end
	if love.keyboard.isDown("d") then
		self.x = self.x + self.speed * dt
	end


	if self.x < 0 then self.x = 0 end
	if self.x > 768 then self.x = 768 end
	if self.y < 32 then self.y = 32 end
	if self.y > 540 then self.y = 540 end

	if love.keyboard.isDown(" ") and self.cooldown <= 0 then
		local bullet = EntityManager.create("Bullet", self.x + 18, self.y)
		bullet:setDir(1)
		self.cooldown = 0.15
	else
		self.cooldown = self.cooldown - 1 * dt
	end
end

function Player:draw()
	love.graphics.draw(self.image, self.x, self.y)
end


return Player